require 'rails/generators/base'

module AutoMock
  module Generators
    class AutoMockGenerator < Rails::Generators::Base
      
      desc <<DESC
Description:
    Add include syntax to use auto_mock in your spec_helper
DESC
      def self.source_root
        @_auto_mock_source_root ||= File.expand_path(File.join(File.dirname(__FILE__), 'templates'))
      end
      
      def insert_include
        spec_helper = 'spec/spec_helper.rb'
        if File.exists?(spec_helper) && File.readlines(spec_helper).grep(/include AutoMock::AutoMockHelper/).blank?
          File.open(spec_helper, 'a') do |f|
            f.puts 'include AutoMock::AutoMockHelper'
          end
        else
          raise Rails::Generators::Error, "First, you must setup rspec by 'rails generate rspec:install'"
        end
      end
      
      def app_name
        Rails.application.class.name
      end
    end
  end
end
